/**
 * @file  XmlRpcServerExtend.cpp
 * @brief XmlRpcServergNX
 *
 * Copyright(C) FUJISOFT Incorporated. All rights reserved. 2013-2014.
 */
#include <iostream>
#include <unistd.h>
#include <sys/syscall.h>
#include <sys/types.h>

#include "XmlRpcServer.h"
#include "XmlRpcServerConnection.h"
#include "XmlRpcServerMethod.h"
#include "XmlRpcSocket.h"
#include "XmlRpcUtil.h"
#include "XmlRpcException.h"
#include "XmlRpcServerExtend.h"

namespace XmlRpc
{
	void ExecThread(CBaseTh *pTh);
	
	//// CBaseThNX
	CBaseTh::CBaseTh() {

	}

	CBaseTh::~CBaseTh() {

	}

	void CBaseTh::StartTh() {

		int iRtn;
		iRtn = pthread_create(&m_tThread, NULL, (void *(*)(void *))ExecThread, (void*)this);
		if(iRtn != 0){
			//
		}
		pthread_detach(m_tThread);
	}


	//// CExThreadNX
	
	CExThread::CExThread() {
		m_bRunning = false;
	}

	CExThread::~CExThread() {

	}

	bool CExThread::isRunning(){
		return m_bRunning;
	}

	void CExThread::setRunning(bool state) {
		m_bRunning = state;

	}
	
	void CExThread::add(XmlRpcSource* source, unsigned eventMask) {
		m_cXmlRpcDispatch.addSource(source,eventMask);
	}

	void CExThread::Running() {
		m_bRunning = true;

		m_cXmlRpcDispatch.work(-1.0);
		m_cXmlRpcDispatch.clear();

		m_bRunning = false;
	}


	//// XmlRpcServerExtendNX
	
	XmlRpcServerExtend::XmlRpcServerExtend() {

	}

	XmlRpcServerExtend::~XmlRpcServerExtend() {

	}

	void XmlRpcServerExtend::acceptConnection() {

		int iAccept = XmlRpcSocket::accept(this->getfd());
		if (iAccept < 0) {
			// Error
		}
		else{
			for(int i=0;i<MAX_THREAD_SIZE;i++) {
				if (!extendTh[i].isRunning()) {
					extendTh[i].add(this->createConnection(iAccept), XmlRpcDispatch::ReadableEvent);
					extendTh[i].setRunning(true);
					extendTh[i].StartTh();
					return;
				}
			}
			XmlRpcSocket::close(iAccept);
		}
	}


	void ExecThread(CBaseTh *pTh) {
		pTh->Running();
	}

}
