/**
 * @file  XmlRpcServerExtend.h
 * @brief XmlRpcServergNX
 *
 * Copyright(C) FUJISOFT Incorporated. All rights reserved. 2013-2014.
 */
#ifndef _XMLRPCSERVER_EXTEND_H_
#define _XMLRPCSERVER_EXTEND_H_

#include <pthread.h>
#include "XmlRpcServer.h"
#include "XmlRpcDispatch.h"

#define MAX_THREAD_SIZE 128

namespace XmlRpc
{
	class CBaseTh {
	  private:
		pthread_t m_tThread;

	  public:
		CBaseTh();
		virtual ~CBaseTh();
		
		void StartTh();
		virtual void Running() = 0;
	};

	class CExThread : public CBaseTh {
	  private:
		XmlRpcDispatch m_cXmlRpcDispatch;
		bool m_bRunning;
		
	  public:
		CExThread();
		virtual ~CExThread();

		bool isRunning();
		void setRunning(bool state);
		void add(XmlRpcSource* source, unsigned eventMask);
		virtual void Running();
	};

	class XmlRpcServerExtend : public XmlRpcServer {
	  private:
		CExThread extendTh[MAX_THREAD_SIZE];
		
	  public:
		XmlRpcServerExtend();
		virtual ~XmlRpcServerExtend();

	  protected:
		virtual void acceptConnection();

		
	};

} // namespace XmlRpc


#endif // _XMLRPCSERVER_EXTEND_H_